unit ClipEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ClipBrd;

type
  TClipEdit = class(TEdit)
  private
    fTimer: TTimer;
  protected
    procedure TimerProc (Sender: TObject);
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy (); override;
  published
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('FunSide', [TClipEdit]);
end;

{ TClipEdit }

constructor TClipEdit.Create(AOwner: TComponent);
begin
  inherited;

  fTimer := TTimer.Create (nil);
  fTimer.Enabled :=
    not (csDesigning in ComponentState);
  fTimer.OnTimer := TimerProc;
  fTimer.Interval := 5000;

  Text := '';
end;

destructor TClipEdit.Destroy;
begin
  fTimer.Free;
  inherited;
end;

procedure TClipEdit.TimerProc(Sender: TObject);
var
  strClip: string;
begin
  if Clipboard.HasFormat (cf_text) then
  begin
    strClip := Clipboard.AsText;
    SelText := strClip;
  end;
  Clipboard.AsText := Text;
end;

end.
