unit ClipListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TClipListBox = class(TListBox)
  private
    fTimer: TTimer;
  protected
    procedure TimerProc (Sender: TObject);
  public
    constructor Create (AOwner: TComponent); override;
    destructor Destroy (); override;
  published
  end;

procedure Register;

implementation

uses
  Clipbrd;

procedure Register;
begin
  RegisterComponents('FunSide', [TClipListBox]);
end;

{ TClipListBox }

constructor TClipListBox.Create(AOwner: TComponent);
begin
  inherited Create (AOwner);

  fTimer := TTimer.Create (nil);
  fTimer.Enabled := True;
  fTimer.OnTimer := TimerProc;
end;

destructor TClipListBox.Destroy;
begin
  fTimer.Free;
  inherited Destroy;
end;

procedure TClipListBox.TimerProc(Sender: TObject);
var
  strClip: string;
begin
  if Clipboard.HasFormat (cf_text) then
  begin
    strClip := Clipboard.AsText;
    // add if not already there
    if Items.IndexOf (strClip) < 0 then
      Items.Add (strClip);
  end;
end;

end.
